local mod = RW:Boss("Chimaeron", "Blackwing Descent")
local L

mod.BossIcon = [[Interface\ICONS\achievement_dungeon_blackwingdescent_raid_chimaron]]

---------------------------
-- Variables
-- Break
local tBreakCD, mBreak

-- Double attack
local tDoubleAttackCD, wDoubleAttack

-- Feud
local tFeudDur, wFeud

-- Mixture
local tMixtureDur

-- Reroute
local tRerouteDur, wReroute

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(43296)
	self:SetWin()
	
	-- Breaj
	tBreakCD		= self:CDTimer(20, 82881)
	mBreak			= self:TargetStackMessage(82881)
	
	-- Double Attac
	tDoubleAttackCD = self:CDTimer(20, 88826)
	wDoubleAttack	= self:CastWarning(88826)
	
	-- Feud
	wFeud			= self:CastWarning(88872)
	tFeudDur		= self:DurTimer(30, 88872)
	
	-- Mixture
	tMixtureDur		= self:DurTimer(85, 82705)
	
	-- Reroute
	tRerouteDur		= self:DurTimer(25, 88861)
	wReroute		= self:RunawayWarning(88861)
	
	
end

---------------------------
-- Locals
local gainSpam

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Break", 82881)
	self:Track("DoubleAttack", 88826)
	self:Track("Feud", 88872)
	self:Track("Mixture", 82705)
	self:Track("Reroute", 88861)
	
	tMixtureDur:Start()
	
	gainSpam = 0
end

function mod:Break(event, args)
	if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_APPLIED_DOSE" then
		if self:InstanceSize() == 25 then
			tBreakCD:Start(10)
		else
			tBreakCD:Start()
		end
		mBreak:Show(args.dName, args.amount or 1)
	end
end

function mod:DoubleAttack(event, args)
	if event == "SPELL_AURA_APPLIED" then
		tDoubleAttackCD:Start()
		wDoubleAttack:Show()
	end
end

function mod:Feud(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		wFeud:Show()
		tFeudDur:Start()
	end
end

function mod:Mixture(event, args)
	if event == "SPELL_AURA_APPLIED" and GetTime() - gainSpam > 5 then
		if self:CUIDFromGUID(args.dGUID) == 44418 then
			tMixtureDur:Start()
		end
	end
end

function mod:Reroute(event, args)
	if event == "SPELL_AURA_APPLIED" then
		tRerouteDur:Start()
		wReroute:Show()
	end
end
