local mod = RW:Boss("Argaloth", "Baradins Hold")
local L

mod.BossIcon = [[Interface\ICONS\achievement_boss_magtheridon]]
mod.SubCatIcon = [[Interface\ICONS\achievement_zone_tolbarad]]
mod.SupressGlobalHealthFrames = true

---------------------------
-- Variables

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(47120)
	self:SetWin()
	
	-- Consuming Shadows
	self:RegisterAlert("mShadowsTarget", self:TargetMessage(88954))
	self:RegisterAlert("tShadowsDur", self:DurTargetTimer(15, 88954))
	self:RegisterAlert("tShadowsCD", self:CDTimer(23.5, 88954))
	
	-- Meteor Slash
	self:RegisterAlert("tSlashCD", self:CDTimer(16, 95172))
	self:RegisterAlert("wSlash", self:CastWarning(95172))
	
	-- Firestorm
	self:RegisterAlert("tStormDur", self:DurTimer(15, 88972))
	self:RegisterAlert("tStormCast", self:CastTimer(3, 88972))
	self:RegisterAlert("wStorm", self:CastWarning(88972))
end

---------------------------
-- Locals

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("ConsumingShadows", 88954, 95173)
	self:Track("MeteorSlash", 88942, 95172)
	self:Track("Firestorm", 88972)
	
	RW.Callbacks:Fire("MPBHealthByID", 47120, nil, {70, 35})
end

function mod:ConsumingShadows(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		self:Call("tShadowsCD", "Start")
	end
end

function mod:MeteorSlash(event, args)
	if event == "SPELL_CAST_START" then
		self:Call("tSlashCD", "Start")
		self:Call("wSlash", "Show")
	end
end

function mod:Firestorm(event, args)
	if event == "SPELL_CAST_START" then
		self:Call("wStorm", "Show")
		self:Call("tStormCast", "Start")
	
	elseif event == "SPELL_AURA_APPLIED" then
		self:Call("tStormDur", "Start")
	end
end