local mod = RW:Boss("Conclave of Wind", "Throne of the Four Winds")
local L

mod.BossIcon = [[Interface\ICONS\ability_druid_galewinds]]
mod.SubCatIcon = [[Interface\ICONS\achievement_boss_murmur]]

-- Anshal:	45870
-- Nezir:	45871
-- Rohash:	45872

---------------------------
-- Variables

-- Anshal
	-- Nurture
	local tNurtureCD, wNurture
-- Nezir
	--
-- Rohash
	--
	
-- Powerup
local tPowerUpCD, tPowerUpDur, wPowerUp

local wReset, tReset

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L["Power Up"] = true
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(45870, 45871, 45872)
	self:SetWin()
	
	-- Anshal
	tNurtureCD		= self:CDTimer(54, 85422)
	wNurture		= self:CastWarning(85422)
	
	-- Nezir
	-- Rohash
	
	-- Power Up
	tPowerUpCD		= self:CDTimer(112, L["Power Up"], [[Interface\ICONS\Spell_Holy_MindVision]], L["Power Up"])
	tPowerUpDur		= self:DurTimer(15, L["Power Up"], [[Interface\ICONS\Spell_Holy_MindVision]], L["Power Up"])
	wPowerUp		= self:Warning(L["Power Up"], [[Interface\ICONS\Spell_Holy_MindVision]], L["Power Up"])
	
	-- Gather Strength
	tReset			= self:CastTimer(60, 86307)
	wReset			= self:CastWarning(86307)
end

---------------------------
-- Locals
local PowerUpSpam

---------------------------
-- Start

function mod:OnEngage(trigger)
	-- Anshal
	self:TrackCastComplete("Nurture", 85422)
	-- Nezir
	-- Rohash
	
	self:Track("PowerUP", 84638, 84644, 84643) -- Zephyr, Sellt Storm, Hurricane
	self:TrackCastStart("Reset", 86307)
	
	PowerUpSpam = 0
	
	tPowerUpCD:Start(90)
end

-- Anshal
do
	function mod:Nurture(args)
		tNurtureCD:Start()
		wNurture:Show()
	end
end

function mod:PowerUP(event, args)
	local t = GetTime()
	if event == "SPELL_CAST_SUCCESS" and t - PowerUpSpam > 3 then
		PowerUpSpam = t
		tPowerUpCD:Start()
		tPowerUpDur:Start()
		wPowerUp:Show()
	end
end

function mod:Reset(args)
	wReset:Show()
	tReset:Start()
end